//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.tiptimes.service.impl;

import com.tiptimes.dao.ActionLogDao;
import com.tiptimes.dao.UserLoginDao;
import com.tiptimes.model.ActionLog;
import com.tiptimes.model.InterfaceLog;
import com.tiptimes.service.ActionLogService;
import com.tiptimes.util.DATEUtil;
import com.tiptimes.util.UUIDUtils;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class ActionLogServiceImpl implements ActionLogService {
    @Autowired
    private ActionLogDao actionLogDao;
    @Autowired
    private UserLoginDao userLoginDao;

    public ActionLogServiceImpl() {
    }

    @Transactional
    public void saveActionLog(ActionLog actionLog) {
        this.actionLogDao.saveActionLog(actionLog);
    }

    public List<ActionLog> listActionLog(String userID, String startTime, String stopTime) {
        List<ActionLog> actionLog_list = this.actionLogDao.listActionLog(userID, startTime, stopTime);
        return actionLog_list.size() == 0 ? null : actionLog_list;
    }

    public String getActionLogStopTime(String userID) {
        List<ActionLog> actionLog_list = this.actionLogDao.listActionLogStopTime(userID);
        return actionLog_list.size() == 0 ? "" : ((ActionLog)actionLog_list.get(0)).getTime();
    }

    @Transactional
    @Async
    public void saveActionLog(String userID, String userName, String remark, String updateID) {
        ActionLog actionLog = new ActionLog();
        actionLog.setId(UUIDUtils.getUUID());
        actionLog.setRemark(remark);
        actionLog.setTime(DATEUtil.getNewDateYMDHNS());
        actionLog.setUpdateID(updateID);
        actionLog.setUserID(userID);
        actionLog.setUserName(userName);
        this.actionLogDao.saveActionLog(actionLog);
    }

    @Transactional
    @Async
    public void saveInterfaceLog(String userID, String goJson, String toJson, HttpServletRequest request) {
        InterfaceLog log = new InterfaceLog();
        log.setIp(getIpAddr(request));
        log.setReturnJson(toJson);
        log.setSubmitJson(goJson);
        log.setTime(DATEUtil.getNewDateYMDHNS());
        log.setUrl(getUrl(request));
        log.setUserID(userID);
        this.actionLogDao.saveInterfaceLog(log);
    }

    @Transactional
    @Async
    public void saveTopSpacePV(String spaceMessageID, HttpServletRequest request) {
        String ip = getIpAddr(request);
        String time = DATEUtil.getNewDateYMD();
        String number = this.actionLogDao.getTopSpacePV(ip, time, spaceMessageID);
        if ("0".equals(number)) {
            this.actionLogDao.saveTopSpacePV(ip, time, spaceMessageID);
        }

    }

    private static String getIpAddr(HttpServletRequest request) {
        String ip = request.getHeader("x-forwarded-for");
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("Proxy-Client-IP");
        }

        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("WL-Proxy-Client-IP");
        }

        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("HTTP_X_FORWARDED_FOR");
        }

        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip) || ip.startsWith("10.")) {
            ip = request.getRemoteAddr();
        }

        return ip;
    }

    private static String getUrl(HttpServletRequest request) {
        try {
            String url = request.getRequestURL().toString();
            return url;
        } catch (Exception var2) {
            return "";
        }
    }
}
