//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.tiptimes.service.impl;

import com.tiptimes.dao.MemberDao;
import com.tiptimes.dao.TeamMessageMemberDao;
import com.tiptimes.dao.TopUserLoginDao;
import com.tiptimes.model.Member;
import com.tiptimes.model.TeamMessageMember;
import com.tiptimes.model.TopUserLogin;
import com.tiptimes.service.MemberService;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class MemberServiceImpl implements MemberService {
    @Autowired
    private MemberDao memberDao;
    @Autowired
    private TopUserLoginDao topUserLoginDao;
    @Autowired
    private TeamMessageMemberDao teamMessageMemberDao;

    public MemberServiceImpl() {
    }

    @Transactional
    public void saveMember(Member member) {
        this.memberDao.saveMember(member);
    }

    @Transactional
    public void saveMember(Member member, TopUserLogin topUserLogin) {
        this.memberDao.saveMember(member);
        this.topUserLoginDao.saveTopUserLogin(topUserLogin);
    }

    @Transactional
    public void updateMember(Member member) {
        this.memberDao.updateMember(member);
    }

    @Transactional
    public void removeMember(String memberID) {
        this.memberDao.removeMember(memberID);
    }

    @Transactional
    public void saveTeamMessageMember(TeamMessageMember teamMessageMember) {
        this.teamMessageMemberDao.saveTeamMessageMember(teamMessageMember);
    }

    public Member listMemberBymemberID(String memberID) {
        List<Member> member_list = this.memberDao.listMemberBymemberID(memberID);
        return member_list.size() == 0 ? null : (Member)member_list.get(0);
    }

    public List<Member> listMemberByTeamMessageID(String teamMessageID, int state, int memberState) {
        List<Member> member_list = this.memberDao.listMemberByTeamMessageID(teamMessageID, state + "", memberState + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberByTeamMessageIDAndOthers(String teamMessageID, int state, int memberState, Member member) {
        List<Member> member_list = this.memberDao.listMemberByTeamMessageIDAndOthers(teamMessageID, state + "", memberState + "", member);
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberByTeamMessageIDSite(String teamMessageID, int state, int memberState) {
        List<Member> member_list = this.memberDao.listMemberByTeamMessageIDSite(teamMessageID, state + "", memberState + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberBySpaceMessageID(String spaceMessageID, int state, int memberState) {
        List<Member> member_list = this.memberDao.listMemberBySpaceMessageID(spaceMessageID, state + "", memberState + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberBySpaceMessageID1(String spaceMessageID, int state, int memberState) {
        List<Member> member_list = this.memberDao.listMemberBySpaceMessageID1(spaceMessageID, state + "", memberState + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberBySpaceMessageID1Site(String spaceMessageID, int state, int memberState) {
        List<Member> member_list = this.memberDao.listMemberBySpaceMessageID1Site(spaceMessageID, state + "", memberState + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberBySpaceMessageID(String spaceMessageID) {
        List<Member> member_list = this.memberDao.listMemberBySpaceMessageIDALL(spaceMessageID);
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberBySpaceMessageIDAndOthers(String spaceMessageID, Member member) {
        List<Member> member_list = this.memberDao.listMemberBySpaceMessageIDALLAndOthers(spaceMessageID, member);
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberByState(int state) {
        List<Member> member_list = this.memberDao.listMemberByState(state + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberByStateSite(int state) {
        List<Member> member_list = this.memberDao.listMemberByStateSite(state + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listMemberAll(Member member) {
        List<Member> member_list = this.memberDao.listMemberAll(member);
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listDismissMemberByTeamMessageID(String teamMessageID, int state) {
        List<Member> member_list = this.memberDao.listDismissMemberByTeamMessageID(teamMessageID, state + "");
        return member_list.size() == 0 ? null : member_list;
    }

    public List<Member> listDismissMemberByTeamMessageIDAndOthers(String teamMessageID, int state, Member member) {
        List<Member> member_list = this.memberDao.listDismissMemberByTeamMessageIDAndOthers(teamMessageID, state + "", member);
        return member_list.size() == 0 ? null : member_list;
    }

    public TeamMessageMember getTeamMessageMemberByTeamMessageID(String teamMessageID, String memberID) {
        List<TeamMessageMember> member_list = this.teamMessageMemberDao.getTeamMessageMemberByTeamMessageID(teamMessageID, memberID);
        return member_list.size() == 0 ? null : (TeamMessageMember)member_list.get(0);
    }

    public List<TeamMessageMember> listTeamMessageMemberByTeamMessageID(String teamMessageID, String memberID) {
        List<TeamMessageMember> member_list = this.teamMessageMemberDao.getTeamMessageMemberByTeamMessageID(teamMessageID, memberID);
        return member_list.size() == 0 ? null : member_list;
    }

    public TeamMessageMember getTeamMessageMemberYesByTeamMessageID(String teamMessageID, String memberID) {
        List<TeamMessageMember> member_list = this.teamMessageMemberDao.getTeamMessageMemberYesByTeamMessageID(teamMessageID, memberID);
        return member_list.size() == 0 ? null : (TeamMessageMember)member_list.get(0);
    }

    public List<TeamMessageMember> getTeamMessageMemberYesByMemberID(String memberID) {
        List<TeamMessageMember> member_list = this.teamMessageMemberDao.getTeamMessageMemberYesByMemberID(memberID);
        return member_list.size() == 0 ? null : member_list;
    }

    public TeamMessageMember getTeamMessageMemberNoByTeamMessageID(String teamMessageID, String memberID) {
        List<TeamMessageMember> member_list = this.teamMessageMemberDao.getTeamMessageMemberNoByTeamMessageID(teamMessageID, memberID);
        return member_list.size() == 0 ? null : (TeamMessageMember)member_list.get(0);
    }

    @Transactional
    public void updateTeamMessageMember(TeamMessageMember teamMessageMember) {
        this.teamMessageMemberDao.updateTeamMessageMember(teamMessageMember);
    }

    @Transactional
    public void updateTeamMessageMemberLabor(TeamMessageMember teamMessageMember) {
        this.teamMessageMemberDao.updateTeamMessageMemberLabor(teamMessageMember);
    }

    public String listMemberAllNumBySpaceMessageCertification(int certification) {
        return this.memberDao.listMemberAllNumBySpaceMessageCertification(certification);
    }

    public Member listMemberByMemberTell(String memberTell) {
        List<Member> members = this.memberDao.listMemberByMemberTell(memberTell);
        return members.size() == 0 ? null : (Member)members.get(0);
    }

    public String getImg(String memberID) {
        List<String> member_list = this.memberDao.getImg(memberID);
        return member_list.size() == 0 ? null : (String)member_list.get(0);
    }

    @Transactional
    public void updateImg(Member member) {
        this.memberDao.updateImg(member);
    }

    public Member listMemberBymemberTopCASUser(String topCASUser) {
        List<Member> members = this.memberDao.listMemberBymemberTopCASUser(topCASUser);
        return members.size() == 0 ? null : (Member)members.get(0);
    }

    public List<TeamMessageMember> getTeamMessageMemberByTeamMessageIDANDMemberState(String teamMessageID, int memberState) {
        List<TeamMessageMember> teamMessageMember_list = this.teamMessageMemberDao.getTeamMessageMemberByTeamMessageIDANDMemberState(teamMessageID, memberState);
        return teamMessageMember_list.size() == 0 ? null : teamMessageMember_list;
    }

    public List<Map<String, Object>> getMemberByTeamMessageIDANDMemberState(String teamMessageID, int memberState, Member member) {
        List<Map<String, Object>> memberList = this.teamMessageMemberDao.getMemberByTeamMessageIDANDMemberState(teamMessageID, memberState, member);
        return memberList.size() < 1 ? null : memberList;
    }
}
